Index: stable/HeuristicLab.Services.WebApp/3.3/Controllers/AppController.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp/3.3/Controllers/AppController.cs	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp/3.3/Controllers/AppController.cs	(revision 12563)
@@ -21,5 +21,4 @@
 
 using System.Web.Mvc;
-using HeuristicLab.Services.WebApp.Configs;
 
 namespace HeuristicLab.Services.WebApp.Controllers {
@@ -31,5 +30,4 @@
         return RedirectPermanent(Request.Url + "/");
       }
-      BundleConfig.AddOrUpdateWebAppBundle();
       return View("~/WebApp/shared/layout/layout.cshtml");
     }
@@ -49,4 +47,7 @@
     }
 
+    public ActionResult RedirectUrl(string url) {
+      return RedirectPermanent(url);
+    }
   }
 }
Index: stable/HeuristicLab.Services.WebApp/3.3/Controllers/AuthenticationController.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp/3.3/Controllers/AuthenticationController.cs	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp/3.3/Controllers/AuthenticationController.cs	(revision 12563)
@@ -1,3 +1,24 @@
-﻿using System.Web.Http;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Web.Http;
 using System.Web.Security;
 using HeuristicLab.Services.WebApp.Controllers.DataTransfer;
Index: stable/HeuristicLab.Services.WebApp/3.3/Controllers/DataTransfer/Plugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp/3.3/Controllers/DataTransfer/Plugin.cs	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp/3.3/Controllers/DataTransfer/Plugin.cs	(revision 12563)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 
 namespace HeuristicLab.Services.WebApp.Controllers.DataTransfer {
@@ -7,4 +28,5 @@
     public DateTime? LastReload { get; set; }
     public int Reloads { get; set; }
+    public string Exception { get; set; }
   }
 }
Index: stable/HeuristicLab.Services.WebApp/3.3/Controllers/DataTransfer/User.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp/3.3/Controllers/DataTransfer/User.cs	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp/3.3/Controllers/DataTransfer/User.cs	(revision 12563)
@@ -1,3 +1,24 @@
-﻿namespace HeuristicLab.Services.WebApp.Controllers.DataTransfer {
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Services.WebApp.Controllers.DataTransfer {
   public class User {
     public string Username { get; set; }
Index: stable/HeuristicLab.Services.WebApp/3.3/Controllers/PluginController.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp/3.3/Controllers/PluginController.cs	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp/3.3/Controllers/PluginController.cs	(revision 12563)
@@ -1,10 +1,32 @@
-﻿using System.Collections.Generic;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
 using System.Linq;
 using System.Web.Http;
+using HeuristicLab.Services.Hive;
 using DTO = HeuristicLab.Services.WebApp.Controllers.DataTransfer;
 
 namespace HeuristicLab.Services.WebApp.Controllers {
 
-  [Authorize(Roles = "Hive Administrator")]
+  [Authorize(Roles = HiveRoles.Administrator)]
   public class PluginController : ApiController {
 
@@ -12,14 +34,17 @@
 
     public IEnumerable<DTO.Plugin> GetPlugins() {
-      var plugins = pluginManager.GetPlugins();
+      var plugins = pluginManager.Plugins;
       return plugins.Select(plugin => new DTO.Plugin {
         Name = plugin.Name,
         AssemblyName = plugin.AssemblyName,
-        LastReload = plugin.LastReload
+        LastReload = plugin.LastReload,
+        Exception = plugin.Exception
       });
     }
 
     public bool ReloadPlugin(string name) {
-      var plugin = PluginManager.Instance.GetPlugin(name);
+      var plugin = pluginManager.GetPlugin(name);
+      if (plugin == null)
+        return false;
       plugin.ReloadControllers();
       return true;
Index: stable/HeuristicLab.Services.WebApp/3.3/Controllers/WebAppControllerSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp/3.3/Controllers/WebAppControllerSelector.cs	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp/3.3/Controllers/WebAppControllerSelector.cs	(revision 12563)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Concurrent;
 using System.Collections.Generic;
@@ -18,5 +39,4 @@
       : base(configuration) {
       this.configuration = configuration;
-      pluginManager.Configuration = configuration;
       controllers = new ConcurrentDictionary<string, HttpControllerDescriptor>();
       LoadAppControllers();
